﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Event: PageChanged (Position As Int)
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: #FFFFFFFF
Sub Class_Globals
	Private mBase As Panel
	Private sv As HorizontalScrollView
	Private panels As List
	Private EventName As String
	Private CallBack As Object
	Public BackgroundColor As Int
	Public CurrentPage As Int
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	panels.Initialize
End Sub

Public Sub AsView As View
	Return sv
End Sub

Sub BringToFront
	sv.BringToFront 
End Sub

Public Sub DesignerCreateView(base As Panel, lbl As Label, props As Map)
	Dim parent As Panel
	Dim r As Reflector
	r.Target = base
	parent = r.RunMethod("getParent")
	base.RemoveView 'remove the base panel
	sv.Initialize(0, "sv") 
	parent.AddView(sv, base.Left, base.Top, base.Width, base.Height)
	base.Color = props.Get("BackgroundColor")
	mBase = parent
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	sv.panel.height = Height
	sv.panel.Width = Width * panels.Size
	For i = 0 To panels.Size - 1
		Dim p As Panel = panels.Get(i)
		p.SetLayoutAnimated(0, i * Width, 0, Width, Height)
	Next
End Sub


Sub Refresh
	sv.panel.Height = mBase.height
	sv.panel.Width = mBase.Width * panels.Size
	For i = 0 To panels.Size - 1
		Dim p As Panel = panels.Get(i)
		p.SetLayoutAnimated(0, i * mBase.width, 0, mBase.Width, mBase.Height)
	Next
End Sub

'Clears all items.
Public Sub Clear
	panels.Clear
	sv.Panel.RemoveAllViews
	sv.panel.Width = 0
End Sub

'Returns the number of items.
Public Sub GetSize As Int
	Return panels.Size
End Sub

' return the underlying panel at a particular index
public Sub GetPageObject(Index As Int) As Panel
	Dim p As Panel
	p = panels.Get(Index) 'this is the parent panel
	Return p.GetView(0)
End Sub

' add a panel page to the scrollview
Public Sub AddPage(pnl As Panel)
	Dim p As Panel
	p.Initialize("p")
	p.Tag = panels.size
	p.AddView(pnl, 0, 0, mBase.width, mBase.height)
	p.Visible = True
	panels.Add(p)
	sv.Panel.AddView(p, 0, 0, mBase.width, mBase.height)
	'necessary otherwise scrollview becomes blank
	Refresh
End Sub

' go to a particular page of the scroll
public Sub GotoPage(Index As Int)
	Dim pgWidth As Int
	CurrentPage = Index
	pgWidth = sv.Panel.Width / panels.size
	pgWidth = Index * pgWidth
	sv.ScrollToNow(pgWidth) 
	DoEvents
End Sub

'Returns the index of the item that holds the given view.
Public Sub GetItemFromView(v As View) As Int
	Dim r As Reflector
	Dim parent, current As Object
	parent = v
	Do While (parent Is Panel) = False Or sv.Panel <> parent
		current = parent
		r.Target = current
		parent = r.RunMethod("getParent")
	Loop
	v = current
	Return v.Tag
End Sub

' fire a page changed event
Sub sv_ScrollChanged(Position As Int)
	For Each p As Panel In panels
		If p.Left = Position Then
			CurrentPage = p.tag
			CallSub2(CallBack, EventName & "_PageChanged", p.Tag)
			Exit
		End If
	Next
End Sub
